
// INCLUDES ///////////////////////////////////////////////
#define WIN32_LEAN_AND_MEAN  // just say no to MFC

#include <windows.h>   // include all the windows headers
#include <windowsx.h>  // include useful macros
#include <stdio.h>
#include <stdlib.h>

// DEFINES ////////////////////////////////////////////////

// Nome da classe
#define WINDOW_CLASS_NAME "EXEMPLO3"

#define WINDOW_WIDTH  400
#define WINDOW_HEIGHT 300



// GLOBALS ////////////////////////////////////////////////
HWND      main_window_handle = NULL; 
HINSTANCE hinstance_app      = NULL; 


// FUNCTIONS //////////////////////////////////////////////
LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{

PAINTSTRUCT		ps;		// usado em WM_PAINT
HDC				hdc;	// apontador para o device context


switch(msg)
	{	
	case WM_CREATE: 
        {
	
        // return OK
		return(0);
		} break;
   
	case WM_PAINT: 
		{
	
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        
        EndPaint(hwnd,&ps);

        // return OK
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		PostQuitMessage(0);

        // return OK
		return(0);
		} break;

	default:break;

    } // end switch


return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////
int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass;  
HWND	   hwnd;	
MSG		   msg;	
HDC        hdc;       

HPEN       pen=NULL;  
int color_change_count = 100; // usado para verificar quando trocar a cor


winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);


hinstance_app = hinstance;


if (!RegisterClassEx(&winclass))
	return(0);


if (!(hwnd = CreateWindowEx(NULL,                
                            WINDOW_CLASS_NAME,   
			    "Exemplo-FPS", 
			    WS_OVERLAPPEDWINDOW | WS_VISIBLE,
			    0,0,	     
			    WINDOW_WIDTH, 
                            WINDOW_HEIGHT,
			    NULL,	
			    NULL,
			    hinstance,
			    NULL)))
return(0);


main_window_handle = hwnd;


hdc = GetDC(hwnd);


srand(GetTickCount());


int x1 = rand()%WINDOW_WIDTH;
int y1 = rand()%WINDOW_HEIGHT;
int x2 = rand()%WINDOW_WIDTH;
int y2 = rand()%WINDOW_HEIGHT;


int x1v = -4 + rand()%8;
int y1v = -4 + rand()%8;
int x2v = -4 + rand()%8;
int y2v = -4 + rand()%8;


while(TRUE)
	{

    DWORD start_time = GetTickCount();
    

	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 

       if (msg.message == WM_QUIT)
           break;
	

	   TranslateMessage(&msg);


	   DispatchMessage(&msg);
	   } 


       if (++color_change_count >= 100)
          {

          color_change_count = 0;


          if (pen) 
             DeleteObject(pen);


          pen = CreatePen(PS_SOLID,1,RGB(rand()%256,rand()%256,rand()%256));


          SelectObject(hdc,pen);

          }



       x1+=x1v;
       y1+=y1v;
       
       x2+=x2v;
       y2+=y2v;


       if (x1 < 0 || x1 >= WINDOW_WIDTH)
          {

          x1v=-x1v;


          x1+=x1v;
          } 

       if (y1 < 0 || y1 >= WINDOW_HEIGHT)
          {

          y1v=-y1v;


          y1+=y1v;
          }
       if (x2 < 0 || x2 >= WINDOW_WIDTH)
          {
        
          x2v=-x2v;


          x2+=x2v;
          } 

       if (y2 < 0 || y2 >= WINDOW_HEIGHT)
          {

          y2v=-y2v;


          y2+=y2v;
          } 


       MoveToEx(hdc, x1,y1, NULL);


       LineTo(hdc,x2,y2);

       // 30 fps aprox. 33 msec.
       while((GetTickCount() - start_time) < 33);
 
       
       
	} 



ReleaseDC(hwnd,hdc);


return(msg.wParam);

}

///////////////////////////////////////////////////////////

