

// INCLUDES ///////////////////////////////////////////////
#define WIN32_LEAN_AND_MEAN  // no para o MFC

#include <windows.h>   // todos os headers do windows
#include <windowsx.h>  // algumas macros
#include <Mmsystem.h> //timeGetTime
#include <stdio.h>


// DEFINES ////////////////////////////////////////////////

// Nome da classe 
#define WINDOW_CLASS_NAME "TIME"

// Identificadores dos timers
#define TIMER_ID1_SEC   1 
#define TIMER_ID3_SEC   2
#define TIMER_ID30_SEC  3

// GLOBALS ////////////////////////////////////////////////
char buffer[280];                     // buffer de impresso
LARGE_INTEGER	g_hrc1,g_hrc2;
LARGE_INTEGER   g_hrcFreq;
bool hasHRC;
DWORD			g_gtc1,g_gtc2,g_gtcLoop;
DWORD			g_tgt1,g_tgt2,g_tgtLoop;


// FUNCTIONS //////////////////////////////////////////////


void do_time(void) {
	if (QueryPerformanceFrequency(&g_hrcFreq)) {
		hasHRC = true;
		QueryPerformanceCounter(&g_hrc1);
		QueryPerformanceCounter(&g_hrc2);
		
	} else {
		hasHRC = false;
	}
	g_gtcLoop = 1;
	g_gtc1 = GetTickCount();
	while ((g_gtc2=GetTickCount())==g_gtc1) {
		g_gtcLoop++;
	}
	g_tgtLoop = 1;
	g_tgt1 = timeGetTime();
	while ((g_tgt2=timeGetTime())==g_tgt1) {
		g_tgtLoop++;
	}


}


LRESULT CALLBACK MyWindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{

PAINTSTRUCT		ps;		// usado em  WM_PAINT
HDC				hdc;	// apontador para um  device context




 
switch(msg)
	{	
	case WM_CREATE: 
        {

		// cdigo de inicializacao do programa

		return(0);
		} break;


	case WM_PAINT: 
		{
		//  valida a janela
		hdc = BeginPaint(hwnd,&ps);	 
		// o codigo grafico vem aqui

        SetTextColor(hdc,RGB(0,0,0));
        SetBkColor(hdc,RGB(255,255,255));
        SetBkMode(hdc,OPAQUE);
 
		if (hasHRC) {

			sprintf(buffer,"HRC Start:   %.f",(float)g_hrc1.QuadPart);
            TextOut(hdc,10,0,buffer,strlen(buffer));
			sprintf(buffer,"HRC End:    %.f",(float)g_hrc2.QuadPart);
            TextOut(hdc,10,15,buffer,strlen(buffer));			
			sprintf(buffer,"HRC Freq:   %.f",(float)g_hrcFreq.QuadPart);
            TextOut(hdc,10,30,buffer,strlen(buffer));
			sprintf(buffer,"Delta Time:   %e sec.",(float)(g_hrc2.QuadPart-g_hrc1.QuadPart)/g_hrcFreq.QuadPart);
            TextOut(hdc,10,45,buffer,strlen(buffer));

		} else {
			sprintf(buffer,"HRC no disponvel");
            TextOut(hdc,10,22,buffer,strlen(buffer));
		}
		sprintf(buffer,"---------------------------------------------");
        TextOut(hdc,10,60,buffer,strlen(buffer));
		sprintf(buffer, "GetTimeCount Start:   %.f",(float) g_gtc1);
		TextOut(hdc,10,75,buffer,strlen(buffer));
		sprintf(buffer, "GetTimeCount End:   %.f",(float) g_gtc2);
		TextOut(hdc,10,90,buffer,strlen(buffer));
		sprintf(buffer, "GetTimeCount DELTA:   %.f milisec.",(float) g_gtc2-g_gtc1);
		TextOut(hdc,10,105,buffer,strlen(buffer));
		sprintf(buffer, "GetTimeCount loop count:   %i",g_gtcLoop);
		TextOut(hdc,10,120,buffer,strlen(buffer));

		sprintf(buffer,"---------------------------------------------");
        TextOut(hdc,10,135,buffer,strlen(buffer));
		sprintf(buffer, "TimeGetTime Start:   %.f",(float) g_tgt1);
		TextOut(hdc,10,150,buffer,strlen(buffer));
		sprintf(buffer, "TimeGetTime End:   %.f",(float) g_tgt2);
		TextOut(hdc,10,165,buffer,strlen(buffer));
		sprintf(buffer, "TimeGetTime DELTA:   %.f milisec.",(float) g_tgt2-g_tgt1);
		TextOut(hdc,10,180,buffer,strlen(buffer));
		sprintf(buffer, "TimeGetTime loop count:   %i",g_tgtLoop);
		TextOut(hdc,10,195,buffer,strlen(buffer));





        EndPaint(hwnd,&ps);

        // returna OK
		return(0);
   		} break;

	case WM_DESTROY: 
		{
		// mata a aplicacao, manda a mensagem WM_QUIT para a pilha 
		PostQuitMessage(0);

        // returna OK
		return(0);
		} break;

	default:break;


    } // end switch

// processa o resto das mensagens 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} 

// WINMAIN ////////////////////////////////////////////////
int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; 
HWND	   hwnd;	 // apontador da janela
MSG		   msg;		 // mensagem generica



do_time();


// Tamanho da estrutura
winclass.cbSize=sizeof(WNDCLASSEX);

// Estilo
winclass.style = CS_DBLCLKS | CS_OWNDC | CS_HREDRAW | CS_VREDRAW;

// Ponteiro para a winproc
winclass.lpfnWndProc=MyWindowProc;

// Projetado para informar ao windows do espao extra que a
// estrutura deveria guardar para informaes em tempo de execuo.
// Na prtica, atribua 0 (zero);
winclass.cbClsExtra=0;
winclass.cbWndExtra=0;

// Ponteiro para a aplicao (que recebemos do winmain). 
winclass.hInstance = hinstance;

//Carrega o icone da janela (normal e pequeno)
winclass.hIcon = LoadIcon(NULL,IDI_APPLICATION);
winclass.hIconSm = LoadIcon(NULL,IDI_APPLICATION);

//Carrega o Cursor default da janela 
winclass.hCursor = LoadCursor(NULL,IDC_ARROW);

//Mostra ao windows como pintar o background
winclass.hbrBackground =  (HBRUSH) GetStockObject(WHITE_BRUSH);

//Nome do menu que a janela deve carregar dos recursos da aplicao
winclass.lpszMenuName=NULL;

//Nome atribuido a esta classe de janela
winclass.lpszClassName=WINDOW_CLASS_NAME;


// Registra a classe definida
if (!RegisterClassEx(&winclass))
	return(0);

// Cria a janela
if (!(hwnd = CreateWindowEx(NULL, // extended style
                            WINDOW_CLASS_NAME,   // class
						    "Exemplo - Time", // title
						    WS_OVERLAPPEDWINDOW | WS_VISIBLE,
					 	    0,0,	    // initial x,y
						    400,400,  // initial width, height
						    NULL,	    // handle to parent 
						    NULL,	    // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

//  loop principal
while(TRUE)
   {

     if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 

           if (msg.message == WM_QUIT)
           break;
	

	   TranslateMessage(&msg);


	   DispatchMessage(&msg);
      } 

}


return(msg.wParam);

} 

///////////////////////////////////////////////////////////

